## ldb 1.0.1~git20120220

=== wscript ===
#!/usr/bin/env python

APPNAME = 'ldb'
VERSION = '1.0.1'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Options

samba_dist.DIST_DIRS('''source4/lib/ldb:. lib/replace:lib/replace lib/talloc:lib/talloc
                        lib/tdb:lib/tdb lib/tevent:lib/tevent lib/popt:lib/popt
                        buildtools:buildtools''')


def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('ldb', noextension='ldb')
    opt.RECURSE('lib/tdb')
    opt.RECURSE('lib/tevent')
    opt.RECURSE('lib/replace')

def configure(conf):
    conf.RECURSE('lib/tdb')
    conf.RECURSE('lib/tevent')
    conf.RECURSE('lib/popt')
    conf.RECURSE('lib/replace')

    # where does the default LIBDIR end up? in conf.env somewhere?
    #
    conf.CONFIG_PATH('LDB_MODULESDIR', conf.SUBST_ENV_VAR('MODULESDIR') + '/ldb')

    conf.env.standalone_ldb = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_ldb:
        if conf.CHECK_BUNDLED_SYSTEM('ldb', minversion=VERSION,
                                     onlyif='talloc tdb tevent',
                                     implied_deps='replace talloc tdb tevent'):
            conf.define('USING_SYSTEM_LDB', 1)
        if conf.CHECK_BUNDLED_SYSTEM('pyldb-util', minversion=VERSION,
                                     onlyif='talloc tdb tevent ldb',
                                     implied_deps='replace talloc tdb tevent ldb'):
            conf.define('USING_SYSTEM_PYLDB_UTIL', 1)

    if conf.env.standalone_ldb:
        conf.CHECK_XSLTPROC_MANPAGES()

        # we need this for the ldap backend
        if conf.CHECK_FUNCS_IN('ber_flush ldap_open ldap_initialize', 'lber ldap', headers='lber.h ldap.h'):
            conf.env.ENABLE_LDAP_BACKEND = True

    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    # we don't want any libraries or modules to rely on runtime
    # resolution of symbols
    if sys.platform != "openbsd4":
        conf.ADD_LDFLAGS('-Wl,-no-undefined', testflags=True)

    conf.SAMBA_CONFIG_H()

def build(bld):
    bld.RECURSE('lib/tdb')
    bld.RECURSE('lib/tevent')
    bld.RECURSE('lib/popt')
    bld.RECURSE('lib/replace')

    if bld.env.standalone_ldb:
        private_library = False
    else:
        private_library = True

    LDB_MAP_SRC = bld.SUBDIR('ldb_map',
                             'ldb_map.c ldb_map_inbound.c ldb_map_outbound.c')

    COMMON_SRC = bld.SUBDIR('common',
                            '''ldb_modules.c ldb_ldif.c ldb_parse.c ldb_msg.c ldb_utf8.c
                            ldb_debug.c ldb_dn.c ldb_match.c ldb_options.c
                            ldb_attributes.c attrib_handlers.c ldb_controls.c qsort.c''')

    bld.SAMBA_MODULE('ldb_ldap', 'ldb_ldap/ldb_ldap.c',
                     init_function='ldb_ldap_init',
                     module_init_name='ldb_init_module',
                     deps='talloc lber ldap ldb',
                     enabled=bld.env.ENABLE_LDAP_BACKEND,
                     internal_module=False,
                     subsystem='ldb')

    # we're not currently linking against the ldap libs, but ldb.pc.in
    # has @LDAP_LIBS@
    bld.env.LDAP_LIBS = ''

    if not 'PACKAGE_VERSION' in bld.env:
        bld.env.PACKAGE_VERSION = VERSION
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'

    if not bld.CONFIG_SET('USING_SYSTEM_PYLDB_UTIL'):
        bld.SAMBA_LIBRARY('pyldb-util',
                          deps='ldb pytalloc-util',
                          source='pyldb_util.c',
                          public_headers='pyldb.h',
                          vnum=VERSION,
                          private_library=private_library,
                          pc_files='pyldb-util.pc',
                          pyext=True)

    if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
        if Options.is_install:
            modules_dir = bld.EXPAND_VARIABLES('${LDB_MODULESDIR}')
        else:
            # when we run from the source directory, we want to use
            # the current modules, not the installed ones
            modules_dir = os.path.join(os.getcwd(), 'bin/modules/ldb')

        abi_match = '!ldb_*module_ops !ldb_*backend_ops ldb_*'

        bld.SAMBA_LIBRARY('ldb',
                          COMMON_SRC + ' ' + LDB_MAP_SRC,
                          deps='tevent LIBLDB_MAIN',
                          includes='include',
                          public_headers='include/ldb.h include/ldb_errors.h '\
                          'include/ldb_module.h include/ldb_handlers.h',
                          pc_files='ldb.pc',
                          vnum=VERSION,
                          private_library=private_library,
                          manpages='man/ldb.3',
                          abi_directory = 'ABI',
                          abi_match = abi_match)

        # generate a include/ldb_version.h
        t = bld.SAMBA_GENERATOR('ldb_version.h',
                                rule='echo "#define LDB_VERSION \\"${LDB_VERSION}\\"" > ${TGT}',
                                target='include/ldb_version.h',
                                public_headers='include/ldb_version.h')
        t.env.LDB_VERSION = VERSION
        bld.add_manual_dependency(bld.path.find_or_declare('include/ldb_version.h'), VERSION)



        bld.SAMBA_PYTHON('pyldb', 'pyldb.c',
                         deps='ldb pyldb-util',
                         realname='ldb.so',
                         cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

        bld.SAMBA_MODULE('ldb_paged_results',
                         'modules/paged_results.c',
                         init_function='ldb_paged_results_init',
                         module_init_name='ldb_init_module',
                         internal_module=False,
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_asq',
                         'modules/asq.c',
                         init_function='ldb_asq_init',
                         module_init_name='ldb_init_module',
                         internal_module=False,
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_server_sort',
                         'modules/sort.c',
                         init_function='ldb_server_sort_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_paged_searches',
                         'modules/paged_searches.c',
                         init_function='ldb_paged_searches_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_rdn_name',
                         'modules/rdn_name.c',
                         init_function='ldb_rdn_name_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_sample',
                         'tests/sample_module.c',
                         init_function='ldb_sample_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_skel',
                         'modules/skel.c',
                         init_function='ldb_skel_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_sqlite3',
                         'sqlite3/ldb_sqlite3.c',
                         init_function='ldb_sqlite3_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         enabled=False,
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_tdb',
                         bld.SUBDIR('ldb_tdb',
                                    '''ldb_tdb.c ldb_pack.c ldb_search.c ldb_index.c
                                    ldb_cache.c ldb_tdb_wrap.c'''),
                         init_function='ldb_tdb_init',
                         module_init_name='ldb_init_module',
                         internal_module=False,
                         deps='tdb ldb',
                         subsystem='ldb')

        # have a separate subsystem for common/ldb.c, so it can rebuild
        # for install with a different -DLDB_MODULESDIR=
        bld.SAMBA_SUBSYSTEM('LIBLDB_MAIN',
                            'common/ldb.c',
                            deps='tevent',
                            includes='include',
                            cflags=['-DLDB_MODULESDIR=\"%s\"' % modules_dir])

        LDB_TOOLS='ldbadd ldbsearch ldbdel ldbmodify ldbedit ldbrename'
        for t in LDB_TOOLS.split():
            bld.SAMBA_BINARY(t, 'tools/%s.c' % t, deps='ldb-cmdline ldb',
                             manpages='man/%s.1' % t)

        # ldbtest doesn't get installed
        bld.SAMBA_BINARY('ldbtest', 'tools/ldbtest.c', deps='ldb-cmdline ldb',
                         install=False)

    bld.SAMBA_LIBRARY('ldb-cmdline',
                      source='tools/ldbutil.c tools/cmdline.c',
                      deps='ldb dl popt',
                      private_library=True)


def test(ctx):
    '''run ldb testsuite'''
    import Utils, samba_utils, shutil
    test_prefix = "%s/st" % (Utils.g_module.blddir)
    shutil.rmtree(test_prefix, ignore_errors=True)
    os.makedirs(test_prefix)
    os.putenv('TEST_DATA_PREFIX', test_prefix)
    cmd = 'tests/test-tdb.sh'
    ret = samba_utils.RUN_COMMAND(cmd)
    print("testsuite returned %d" % ret)
    # FIXME: Run python testsuite
    sys.exit(ret)

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    import samba_utils
    samba_utils.reconfigure(ctx)

=== buildtools/wafsamba/wscript ===
#!/usr/bin/env python

# this is a base set of waf rules that everything else pulls in first

import sys, wafsamba, Configure, Logs
import Options, os, preproc
from samba_utils import *
from optparse import SUPPRESS_HELP

# this forces configure to be re-run if any of the configure
# sections of the build scripts change. We have to check
# for this in sys.argv as options have not yet been parsed when
# we need to set this. This is off by default until some issues
# are resolved related to WAFCACHE. It will need a lot of testing
# before it is enabled by default.
if '--enable-auto-reconfigure' in sys.argv:
    Configure.autoconfig = True

def set_options(opt):
    opt.tool_options('compiler_cc')

    opt.tool_options('gnu_dirs')

    gr = opt.option_group('library handling options')

    gr.add_option('--bundled-libraries',
                   help=("comma separated list of bundled libraries. May include !LIBNAME to disable bundling a library. Can be 'NONE' or 'ALL' [auto]"),
                   action="store", dest='BUNDLED_LIBS', default='')

    extension_default = Options.options['PRIVATE_EXTENSION_DEFAULT']
    gr.add_option('--private-library-extension',
                   help=("name extension for private libraries [%s]" % extension_default),
                   action="store", dest='PRIVATE_EXTENSION', default=extension_default)

    extension_exception = Options.options['PRIVATE_EXTENSION_EXCEPTION']
    gr.add_option('--private-extension-exception',
                   help=("comma separated list of libraries to not apply extension to [%s]" % extension_exception),
                   action="store", dest='PRIVATE_EXTENSION_EXCEPTION', default=extension_exception)

    builtin_defauilt = Options.options['BUILTIN_LIBRARIES_DEFAULT']
    gr.add_option('--builtin-libraries',
                   help=("command separated list of libraries to build directly into binaries [%s]" % builtin_defauilt),
                   action="store", dest='BUILTIN_LIBRARIES', default=builtin_defauilt)

    gr.add_option('--minimum-library-version',
                   help=("list of minimum system library versions (LIBNAME1:version,LIBNAME2:version)"),
                   action="store", dest='MINIMUM_LIBRARY_VERSION', default='')

    gr.add_option('--disable-shared',
                   help=("Disable all use of shared libraries"),
                   action="store_true", dest='disable_shared', default=False)
    gr.add_option('--disable-rpath',
                   help=("Disable use of rpath for build binaries"),
                   action="store_true", dest='disable_rpath_build', default=False)
    gr.add_option('--disable-rpath-install',
                   help=("Disable use of rpath for library path in installed files"),
                   action="store_true", dest='disable_rpath_install', default=False)
    gr.add_option('--disable-rpath-private-install',
                   help=("Disable use of rpath for private library path in installed files"),
                   action="store_true", dest='disable_rpath_private_install', default=False)
    gr.add_option('--nonshared-binary',
                   help=("Disable use of shared libs for the listed binaries"),
                   action="store", dest='NONSHARED_BINARIES', default='')
    gr.add_option('--disable-symbol-versions',
                   help=("Disable use of the --version-script linker option"),
                   action="store_true", dest='disable_symbol_versions', default=False)

    opt.add_option('--with-modulesdir',
                   help=("modules directory [PREFIX/modules]"),
                   action="store", dest='MODULESDIR', default='${PREFIX}/modules')

    opt.add_option('--with-privatelibdir',
                   help=("private library directory [PREFIX/lib/%s]" % Utils.g_module.APPNAME),
                   action="store", dest='PRIVATELIBDIR', default=None)

    gr = opt.option_group('developer options')

    gr.add_option('-C',
                   help='enable configure cacheing',
                   action='store_true', dest='enable_configure_cache')
    gr.add_option('--enable-auto-reconfigure',
                   help='enable automatic reconfigure on build',
                   action='store_true', dest='enable_auto_reconfigure')
    gr.add_option('--enable-developer',
                   help=("Turn on developer warnings and debugging"),
                   action="store_true", dest='developer', default=False)
    gr.add_option('--picky-developer',
                   help=("Treat all warnings as errors (enable -Werror)"),
                   action="store_true", dest='picky_developer', default=False)
    gr.add_option('--fatal-errors',
                   help=("Stop compilation on first error (enable -Wfatal-errors)"),
                   action="store_true", dest='fatal_errors', default=False)
    gr.add_option('--enable-gccdeps',
                   help=("Enable use of gcc -MD dependency module"),
                   action="store_true", dest='enable_gccdeps', default=True)
    gr.add_option('--timestamp-dependencies',
                   help=("use file timestamps instead of content for build dependencies (BROKEN)"),
                   action="store_true", dest='timestamp_dependencies', default=False)
    gr.add_option('--pedantic',
		   help=("Enable even more compiler warnings"),
		   action='store_true', dest='pedantic', default=False)
    gr.add_option('--git-local-changes',
		   help=("mark version with + if local git changes"),
		   action='store_true', dest='GIT_LOCAL_CHANGES', default=False)

    gr.add_option('--abi-check',
		   help=("Check ABI signatures for libraries"),
		   action='store_true', dest='ABI_CHECK', default=False)
    gr.add_option('--abi-check-disable',
		   help=("Disable ABI checking (used with --enable-developer)"),
		   action='store_true', dest='ABI_CHECK_DISABLE', default=False)
    gr.add_option('--abi-update',
		   help=("Update ABI signature files for libraries"),
		   action='store_true', dest='ABI_UPDATE', default=False)

    gr.add_option('--show-deps',
		   help=("Show dependency tree for the given target"),
		   dest='SHOWDEPS', default='')

    gr.add_option('--symbol-check',
                  help=("check symbols in object files against project rules"),
                  action='store_true', dest='SYMBOLCHECK', default=False)

    gr.add_option('--show-duplicates',
                  help=("Show objects which are included in multiple binaries or libraries"),
                  action='store_true', dest='SHOW_DUPLICATES', default=False)

    gr = opt.add_option_group('cross compilation options')

    gr.add_option('--cross-compile',
		   help=("configure for cross-compilation"),
		   action='store_true', dest='CROSS_COMPILE', default=False)
    gr.add_option('--cross-execute',
		   help=("command prefix to use for cross-execution in configure"),
		   action='store', dest='CROSS_EXECUTE', default='')
    gr.add_option('--cross-answers',
		   help=("answers to cross-compilation configuration (auto modified)"),
		   action='store', dest='CROSS_ANSWERS', default='')
    gr.add_option('--hostcc',
		   help=("set host compiler when cross compiling"),
		   action='store', dest='HOSTCC', default=False)

    # we use SUPPRESS_HELP for these, as they are ignored, and are there only
    # to allow existing RPM spec files to work
    opt.add_option('--build',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_BUILD', default='')
    opt.add_option('--host',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_HOST', default='')
    opt.add_option('--program-prefix',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_PROGRAM_PREFIX', default='')
    opt.add_option('--disable-dependency-tracking',
		   help=SUPPRESS_HELP,
		   action='store_true', dest='AUTOCONF_DISABLE_DEPENDENCY_TRACKING', default=False)

    gr = opt.option_group('dist options')
    gr.add_option('--sign-release',
                   help='sign the release tarball created by waf dist',
                   action='store_true', dest='SIGN_RELEASE')
    gr.add_option('--tag',
                   help='tag release in git at the same time',
                   type='string', action='store', dest='TAG_RELEASE')


@wafsamba.runonce
def configure(conf):
    conf.env.hlist = []
    conf.env.srcdir = conf.srcdir

    if Options.options.timestamp_dependencies:
        conf.ENABLE_TIMESTAMP_DEPENDENCIES()

    conf.SETUP_CONFIGURE_CACHE(Options.options.enable_configure_cache)

    # load our local waf extensions
    conf.check_tool('gnu_dirs')
    conf.check_tool('wafsamba')

    conf.CHECK_CC_ENV()

    conf.check_tool('compiler_cc')

    # we need git for 'waf dist'
    conf.find_program('git', var='GIT')

    # older gcc versions (< 4.4) does not work with gccdeps, so we have to see if the .d file is generated
    if Options.options.enable_gccdeps:
        from TaskGen import feature, after
        @feature('testd')
        @after('apply_core')
        def check_d(self):
            tsk = self.compiled_tasks[0]
            tsk.outputs.append(tsk.outputs[0].change_ext('.d'))

        import Task
        cc = Task.TaskBase.classes['cc']
        oldmeth = cc.run

        cc.run = Task.compile_fun_noshell('cc', '${CC} ${CCFLAGS} ${CPPFLAGS} ${_CCINCFLAGS} ${_CCDEFFLAGS} ${CC_SRC_F}${SRC} ${CC_TGT_F}${TGT[0].abspath(env)}')[0]
        try:
            try:
                conf.check(features='cc testd', fragment='int main() {return 0;}\n', ccflags=['-MD'], mandatory=True, msg='Check for -MD')
            except:
                pass
            else:
                conf.check_tool('gccdeps', tooldir=conf.srcdir + "/buildtools/wafsamba")
        finally:
            cc.run = oldmeth

    # make the install paths available in environment
    conf.env.LIBDIR = Options.options.LIBDIR or '${PREFIX}/lib'
    conf.env.BINDIR = Options.options.BINDIR or '${PREFIX}/bin'
    conf.env.SBINDIR = Options.options.SBINDIR or '${PREFIX}/sbin'
    conf.env.MODULESDIR = Options.options.MODULESDIR
    conf.env.PRIVATELIBDIR = Options.options.PRIVATELIBDIR
    conf.env.BUNDLED_LIBS = Options.options.BUNDLED_LIBS.split(',')
    conf.env.BUILTIN_LIBRARIES = Options.options.BUILTIN_LIBRARIES.split(',')
    conf.env.DISABLE_SHARED = Options.options.disable_shared
    conf.env.NONSHARED_BINARIES = Options.options.NONSHARED_BINARIES.split(',')

    conf.env.PRIVATE_EXTENSION = Options.options.PRIVATE_EXTENSION
    conf.env.PRIVATE_EXTENSION_EXCEPTION = Options.options.PRIVATE_EXTENSION_EXCEPTION.split(',')

    conf.env.CROSS_COMPILE = Options.options.CROSS_COMPILE
    conf.env.CROSS_EXECUTE = Options.options.CROSS_EXECUTE
    conf.env.CROSS_ANSWERS = Options.options.CROSS_ANSWERS
    conf.env.HOSTCC        = Options.options.HOSTCC

    conf.env.AUTOCONF_BUILD = Options.options.AUTOCONF_BUILD
    conf.env.AUTOCONF_HOST  = Options.options.AUTOCONF_HOST
    conf.env.AUTOCONF_PROGRAM_PREFIX = Options.options.AUTOCONF_PROGRAM_PREFIX

    if (conf.env.AUTOCONF_HOST and
        conf.env.AUTOCONF_BUILD and
        conf.env.AUTOCONF_BUILD != conf.env.AUTOCONF_HOST):
        Logs.error('ERROR: Mismatch between --build and --host. Please use --cross-compile instead')
        sys.exit(1)
    if conf.env.AUTOCONF_PROGRAM_PREFIX:
        Logs.error('ERROR: --program-prefix not supported')
        sys.exit(1)

    # enable ABI checking for developers
    conf.env.ABI_CHECK = Options.options.ABI_CHECK or Options.options.developer
    if Options.options.ABI_CHECK_DISABLE:
        conf.env.ABI_CHECK = False
    try:
        conf.find_program('gdb', mandatory=True)
    except:
        conf.env.ABI_CHECK = False

    conf.env.GIT_LOCAL_CHANGES = Options.options.GIT_LOCAL_CHANGES

    conf.CHECK_COMMAND(['uname', '-a'],
                       msg='Checking build system',
                       define='BUILD_SYSTEM',
                       on_target=False)
    conf.CHECK_UNAME()

    # see if we can compile and run a simple C program

=== lib/replace/wscript ===
#!/usr/bin/env python

APPNAME = 'libreplace'
VERSION = '1.2.1'

blddir = 'bin'

import sys, os, Utils

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist
import Options, os, preproc

samba_dist.DIST_DIRS('lib/replace buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.PRIVATE_EXTENSION_DEFAULT('')
    opt.RECURSE('buildtools/wafsamba')

@wafsamba.runonce
def configure(conf):
    conf.RECURSE('buildtools/wafsamba')

    conf.env.standalone_replace = conf.IN_LAUNCH_DIR()

    conf.DEFINE('LIBREPLACE_NETWORK_CHECKS', 1)

    # on Tru64 certain features are only available with _OSF_SOURCE set to 1
    # and _XOPEN_SOURCE set to 600
    if conf.env['SYSTEM_UNAME_SYSNAME'] == 'OSF1':
        conf.DEFINE('_OSF_SOURCE', 1, add_to_cflags=True)
        conf.DEFINE('_XOPEN_SOURCE', 600, add_to_cflags=True)

    conf.CHECK_HEADERS('linux/types.h crypt.h locale.h acl/libacl.h compat.h')
    conf.CHECK_HEADERS('acl/libacl.h attr/xattr.h compat.h ctype.h dustat.h')
    conf.CHECK_HEADERS('fcntl.h fnmatch.h glob.h history.h krb5.h langinfo.h')
    conf.CHECK_HEADERS('libaio.h locale.h ndir.h pwd.h')
    conf.CHECK_HEADERS('shadow.h sys/acl.h')
    conf.CHECK_HEADERS('sys/attributes.h sys/capability.h sys/dir.h sys/epoll.h')
    conf.CHECK_HEADERS('sys/fcntl.h sys/filio.h sys/filsys.h sys/fs/s5param.h sys/fs/vx/quota.h')
    conf.CHECK_HEADERS('sys/id.h sys/ioctl.h sys/ipc.h sys/mman.h sys/mode.h sys/ndir.h sys/priv.h')
    conf.CHECK_HEADERS('sys/resource.h sys/security.h sys/shm.h sys/statfs.h sys/statvfs.h sys/termio.h')
    conf.CHECK_HEADERS('sys/vfs.h sys/xattr.h termio.h termios.h sys/file.h')
    conf.CHECK_HEADERS('sys/wait.h sys/stat.h malloc.h grp.h')
    conf.CHECK_HEADERS('sys/select.h setjmp.h utime.h sys/syslog.h syslog.h')
    conf.CHECK_HEADERS('stdarg.h vararg.h sys/mount.h mntent.h')
    conf.CHECK_HEADERS('stropts.h unix.h string.h strings.h sys/param.h limits.h')
    conf.CHECK_HEADERS('''sys/socket.h netinet/in.h netdb.h arpa/inet.h netinet/in_systm.h
                          netinet/ip.h netinet/tcp.h netinet/in_ip.h
                          sys/sockio.h sys/un.h''', together=True)
    conf.CHECK_HEADERS('sys/uio.h ifaddrs.h direct.h dirent.h')
    conf.CHECK_HEADERS('windows.h winsock2.h ws2tcpip.h')
    conf.CHECK_HEADERS('libintl.h errno.h')
    conf.CHECK_HEADERS('gcrypt.h getopt.h iconv.h')
    conf.CHECK_HEADERS('sys/inotify.h memory.h nss.h sasl/sasl.h')
    conf.CHECK_HEADERS('security/pam_appl.h sys/inotify.h zlib.h asm/unistd.h')
    conf.CHECK_HEADERS('aio.h sys/unistd.h rpc/rpc.h rpc/nettype.h alloca.h float.h')

    conf.CHECK_HEADERS('rpcsvc/nis.h rpcsvc/ypclnt.h sys/prctl.h sys/sysctl.h')
    conf.CHECK_HEADERS('sys/fileio.h sys/filesys.h sys/dustat.h sys/sysmacros.h')
    conf.CHECK_HEADERS('xfs/libxfs.h netgroup.h rpcsvc/yp_prot.h')
    conf.CHECK_HEADERS('valgrind.h valgrind/valgrind.h valgrind/memcheck.h')
    conf.CHECK_HEADERS('nss_common.h nsswitch.h ns_api.h')
    conf.CHECK_HEADERS('sys/extattr.h sys/ea.h sys/proplist.h sys/cdefs.h')
    conf.CHECK_HEADERS('utmp.h utmpx.h lastlog.h')
    conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')

    conf.CHECK_TYPES('"long long" intptr_t uintptr_t ptrdiff_t comparison_fn_t')
    conf.CHECK_TYPE('_Bool', define='HAVE__Bool')
    conf.CHECK_TYPE('bool', define='HAVE_BOOL')

    conf.CHECK_TYPE('int8_t', 'char')
    conf.CHECK_TYPE('uint8_t', 'unsigned char')
    conf.CHECK_TYPE('int16_t', 'short')
    conf.CHECK_TYPE('uint16_t', 'unsigned short')
    conf.CHECK_TYPE('int32_t', 'int')
    conf.CHECK_TYPE('uint32_t', 'unsigned')
    conf.CHECK_TYPE('int64_t', 'long long')
    conf.CHECK_TYPE('uint64_t', 'unsigned long long')
    conf.CHECK_TYPE('size_t', 'unsigned int')
    conf.CHECK_TYPE('ssize_t', 'int')
    conf.CHECK_TYPE('ino_t', 'unsigned')
    conf.CHECK_TYPE('loff_t', 'off_t')
    conf.CHECK_TYPE('offset_t', 'loff_t')
    conf.CHECK_TYPE('volatile int', define='HAVE_VOLATILE')
    conf.CHECK_TYPE('uint_t', 'unsigned int')

    conf.CHECK_SIZEOF('bool char int "long long" long short size_t ssize_t')
    conf.CHECK_SIZEOF('int8_t uint8_t int16_t uint16_t int32_t uint32_t int64_t uint64_t')
    conf.CHECK_SIZEOF('void*', define='SIZEOF_VOID_P')
    conf.CHECK_SIZEOF('off_t dev_t ino_t time_t')

    conf.CHECK_TYPES('socklen_t', headers='sys/socket.h')
    conf.CHECK_TYPE_IN('struct ifaddrs', 'ifaddrs.h')
    conf.CHECK_TYPE_IN('struct addrinfo', 'netdb.h')
    conf.CHECK_TYPE_IN('struct sockaddr', 'sys/socket.h')
    conf.CHECK_CODE('struct sockaddr_in6 x', define='HAVE_STRUCT_SOCKADDR_IN6',
                    headers='sys/socket.h netdb.h netinet/in.h')
    conf.CHECK_TYPE_IN('struct sockaddr_storage', 'sys/socket.h')
    conf.CHECK_TYPE_IN('sa_family_t', 'sys/socket.h')

    conf.CHECK_TYPE_IN('sig_atomic_t', 'signal.h', define='HAVE_SIG_ATOMIC_T_TYPE')

    conf.CHECK_FUNCS_IN('''inet_ntoa inet_aton inet_ntop inet_pton connect gethostbyname
                           getaddrinfo getnameinfo freeaddrinfo gai_strerror socketpair''',
                        'socket nsl', checklibc=True,
                        headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h')

    # Some old Linux systems have broken header files and
    # miss the IPV6_V6ONLY define in netinet/in.h,
    # but have it in linux/in6.h.
    # We can't include both files so we just check if the value
    # if defined and do the replacement in system/network.h
    if not conf.CHECK_VARIABLE('IPV6_V6ONLY',
                               headers='sys/socket.h netdb.h netinet/in.h'):
        conf.CHECK_CODE('''
                        #include <linux/in6.h>
                        #if (IPV6_V6ONLY != 26)
                        #error no IPV6_V6ONLY support on linux
                        #endif
                        int main(void) { return IPV6_V6ONLY; }
                        ''',
                        define='HAVE_LINUX_IPV6_V6ONLY_26',
                        addmain=False,
                        msg='Checking for IPV6_V6ONLY in linux/in6.h',
                        local_include=False)

    conf.CHECK_CODE('''
                       struct sockaddr_storage sa_store;
                       struct addrinfo *ai = NULL;
                       struct in6_addr in6addr;
                       int idx = if_nametoindex("iface1");
                       int s = socket(AF_INET6, SOCK_STREAM, 0);
                       int ret = getaddrinfo(NULL, NULL, NULL, &ai);
                       if (ret != 0) {
                           const char *es = gai_strerror(ret);
                       }
                       freeaddrinfo(ai);
                       {
                          int val = 1;
                          #ifdef HAVE_LINUX_IPV6_V6ONLY_26
                          #define IPV6_V6ONLY 26
                          #endif
                          ret = setsockopt(s, IPPROTO_IPV6, IPV6_V6ONLY,
                                           (const void *)&val, sizeof(val));
                       }
                       ''',
                    define='HAVE_IPV6',
                    lib='nsl socket',
                    headers='sys/socket.h netdb.h netinet/in.h')

    # these may be builtins, so we need the link=False strategy
    conf.CHECK_FUNCS('strdup memmem printf memset memcpy memmove strcpy strncpy bzero', link=False)

    conf.CHECK_FUNCS('shl_load shl_unload shl_findsym')
    conf.CHECK_FUNCS('pipe strftime srandom random srand rand usleep setbuffer')
    conf.CHECK_FUNCS('lstat getpgrp utime utimes seteuid setresuid setegid')
    conf.CHECK_FUNCS('setresgid chroot strerror vsyslog setlinebuf mktime')
    conf.CHECK_FUNCS('ftruncate chsize rename waitpid wait4 strlcpy strlcat')
    conf.CHECK_FUNCS('initgroups pread pwrite strndup strcasestr')
    conf.CHECK_FUNCS('strtok_r mkdtemp dup2 dprintf vdprintf isatty chown lchown')
    conf.CHECK_FUNCS('link readlink symlink realpath snprintf vsnprintf')
    conf.CHECK_FUNCS('asprintf vasprintf setenv unsetenv strnlen strtoull __strtoull')
    conf.CHECK_FUNCS('strtouq strtoll __strtoll strtoq')
    #Some OS (ie. freebsd) return EINVAL if the convertion could not be done, it's not what we expect
    #Let's detect those cases
    if conf.CONFIG_SET('HAVE_STRTOLL'):
        conf.CHECK_CODE('''
                        long long nb = strtoll("Text", NULL, 0);
                        if (errno == EINVAL) {
                            return 0;
                        } else {
                            return 1;
                        }
                        ''',
                        msg="Checking correct behavior of strtoll",
                        headers = 'errno.h',
                        execute = True,
                        define_ret = True,
                        define = 'HAVE_BSD_STRTOLL',
                        )
    conf.CHECK_FUNCS('if_nametoindex strerror_r')
    conf.CHECK_FUNCS('getdirentries getdents syslog')
    conf.CHECK_FUNCS('gai_strerror get_current_dir_name')
    conf.CHECK_FUNCS('timegm getifaddrs freeifaddrs mmap setgroups setsid')
    conf.CHECK_FUNCS('getgrent_r getgrgid_r getgrnam_r getgrouplist getpagesize')
    conf.CHECK_FUNCS('getpwent_r getpwnam_r getpwuid_r epoll_create')

    conf.CHECK_FUNCS_IN('dlopen dlsym dlerror dlclose', 'dl',
                        checklibc=True, headers='dlfcn.h dl.h')

    conf.CHECK_C_PROTOTYPE('dlopen', 'void *dlopen(const char* filename, unsigned int flags)',
                           define='DLOPEN_TAKES_UNSIGNED_FLAGS', headers='dlfcn.h dl.h')

    if conf.CHECK_FUNCS_IN('fdatasync', 'rt', checklibc=True):
        # some systems are missing the declaration
        conf.CHECK_DECLS('fdatasync')

    if conf.CHECK_FUNCS_IN('clock_gettime', 'rt', checklibc=True):
        for c in ['CLOCK_MONOTONIC', 'CLOCK_PROCESS_CPUTIME_ID', 'CLOCK_REALTIME']:
            conf.CHECK_CODE('''
			    #if TIME_WITH_SYS_TIME
			    # include <sys/time.h>
			    # include <time.h>
			    #else
			    # if HAVE_SYS_TIME_H
			    #  include <sys/time.h>
			    # else
			    #  include <time.h>
			    # endif
			    #endif
			    clockid_t clk = %s''' % c,
			    'HAVE_%s' % c,
			    msg='Checking whether the clock_gettime clock ID %s is available' % c)


    # these headers need to be tested as a group on freebsd
    conf.CHECK_HEADERS(headers='sys/socket.h net/if.h', together=True)
    conf.CHECK_HEADERS(headers='netinet/in.h arpa/nameser.h resolv.h', together=True)
    conf.CHECK_FUNCS_IN('res_search', 'resolv', checklibc=True,
                        headers='netinet/in.h arpa/nameser.h resolv.h')


    if not conf.CHECK_FUNCS_IN('gettext', 'intl', checklibc=True, headers='libintl.h'):
    # Some hosts need lib iconv for linking with lib intl
    # So we try with flags just in case it helps.
        oldflags = conf.env['LDFLAGS_INTL']
        conf.env['LDFLAGS_INTL'] = "-liconv"
        if not conf.CHECK_LIB('intl'):
            conf.env['LDFLAGS_INTL'] = oldflags
        else:
            conf.CHECK_FUNCS_IN('gettext', 'intl', checklibc=True, headers='libintl.h')

    conf.CHECK_FUNCS_IN('dgettext gettext', 'intl', headers='libintl.h')
    conf.CHECK_FUNCS_IN('pthread_create', 'pthread', checklibc=True, headers='pthread.h')

    conf.CHECK_FUNCS_IN('crypt', 'crypt', checklibc=True)

    conf.CHECK_VARIABLE('rl_event_hook', define='HAVE_DECL_RL_EVENT_HOOK', always=True,
                        headers='readline.h readline/readline.h readline/history.h')

    conf.CHECK_DECLS('snprintf vsnprintf asprintf vasprintf')

    conf.CHECK_DECLS('errno', headers='errno.h', reverse=True)
    conf.CHECK_DECLS('environ getgrent_r getpwent_r', reverse=True, headers='pwd.h grp.h')
    conf.CHECK_DECLS('pread pwrite setenv setresgid setresuid', reverse=True)

=== debian/changelog ===
ldb (1:1.0.1~git20120220-1) experimental; urgency=low

  * New upstream snapshot.

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 20 Feb 2011 14:42:57 +0100

ldb (1:1.0.0-2) unstable; urgency=low

  * Add breaks/conflicts for libldb0.

 -- Jelmer Vernooij <jelmer@debian.org>  Sat, 12 Feb 2011 18:23:07 +0100

ldb (1:1.0.0-1) unstable; urgency=low

  * Run test suite during package build.
  * Add references to common license files in copyright file.
  * New upstream release.
   + Rename libldb0 to libldb1 after upstream soname bump.

 -- Jelmer Vernooij <jelmer@debian.org>  Sat, 12 Feb 2011 03:45:51 +0100

ldb (1:0.9.22-2) experimental; urgency=low

  * New upstream release.
   + Add python-ldb-dev package.
   + Uses version symbols.
  * Switch to python-support.
  * Link with --as-needed.
  * Run test suite during build.

 -- Jelmer Vernooij <jelmer@debian.org>  Wed, 22 Dec 2010 00:05:26 +0100

ldb (1:0.9.22-1) unstable; urgency=low

  * New upstream release.
   + Add python-ldb-dev package.
   + Uses version symbols.
  * Switch to python-support.
  * Link with --as-needed.
  * Run test suite during build.

 -- Jelmer Vernooij <jelmer@debian.org>  Wed, 22 Dec 2010 00:05:26 +0100

=== debian/control ===
Source: ldb
Section: devel
Priority: optional
Maintainer: Jelmer Vernooij <jelmer@debian.org>
Build-Depends: debhelper (>> 6.0.7~), libtdb-dev (>= 1.2.9~), libtalloc-dev (>= 2.0.5~), libtevent-dev (>= 0.9.10~), pkg-config, libpopt-dev, docbook-xsl, docbook-xml, xsltproc, python-dev, python-support, python-tdb (>= 1.2.9~), libldap2-dev, python-talloc-dev (>= 2.0.5~)
Homepage: http://ldb.samba.org/
Standards-Version: 3.9.1
Vcs-Bzr: http://bzr.debian.org/pkg-samba/ldb/unstable
XS-Python-Version: all

Package: libldb1
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libldb0
Breaks: libldb0
Description: LDAP-like embedded database - shared library
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 It provides a fast database with an LDAP-like API designed
 to be used within an application. In some ways it can be seen as a
 intermediate solution between key-value pair databases and a real LDAP
 database.
 .
 This package contains the shared library file.

Package: ldb-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LDAP-like embedded database - tools
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 What ldb does is provide a fast database with an LDAP-like API designed
 to be used within an application. In some ways it can be seen as a
 intermediate solution between key-value pair databases and a real LDAP
 database.
 .
 This package contains bundled test and utility binaries

Package: libldb-dev
Section: libdevel
Architecture: any
Depends: libc6-dev, libldb1 (= ${binary:Version}), libtalloc-dev, pkg-config, libtdb-dev, ${misc:Depends}
Description: LDAP-like embedded database - development files
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 What ldb does is provide a fast database with an LDAP-like API designed
 to be used within an application. In some ways it can be seen as a
 intermediate solution between key-value pair databases and a real LDAP
 database.
 .
 This package contains the development files.

Package: python-ldb
Section: python
Architecture: any
Depends: ${python:Depends}, libldb1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: Python bindings for LDB
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 This package contains the Python bindings.

Package: python-ldb-dev
Section: libdevel
Architecture: any
Depends: libc6-dev, python-ldb (= ${binary:Version}), libldb-dev, pkg-config, ${misc:Depends}
Description: LDB python bindings - development files
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 What ldb does is provide a fast database with an LDAP-like API designed
 to be used within an application. In some ways it can be seen as a
 intermediate solution between key-value pair databases and a real LDAP
 database.
 .
 This package contains the development files for the Python bindings.

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS = -g -Wall

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif

LDFLAGS += -Wl,--as-needed

DESTDIR=$(CURDIR)/debian/tmp
WAF=buildtools/bin/waf

configure: configure-stamp
configure-stamp:
	dh_testdir
	PYTHON=`which python` PYTHON_CONFIG=`which python-config` CFLAGS="$(CFLAGS)" ./configure --prefix=/usr --disable-rpath-install \
		--bundled-libraries=NONE \
		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
		--with-modulesdir=/usr/lib/ldb/modules
	touch configure-stamp

get-orig-source:
	./debian/build-orig.sh

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	-$(WAF) clean
	rm -rf buildtools/bin/.waf-*
	rm -f buildtools/wafsamba/*.pyc
	dh_clean

build: configure build-stamp
build-stamp: 
	$(MAKE)
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) check
endif

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	$(MAKE) install DESTDIR=$(DESTDIR)
	ar cr $(DESTDIR)/usr/lib/libldb.a bin/default/common/*.o
	dh_install --fail-missing --list-missing --sourcedir=$(DESTDIR)

binary-indep:
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installman
	dh_installexamples
	dh_installchangelogs
	dh_lintian
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs -- -c4
	dh_pysupport
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=3
ftp://ftp.samba.org/pub/ldb/ldb-(.+).tar.gz

## ldb 1.1.0

=== debian/changelog ===
ldb (1:1.1.0-1) unstable; urgency=low

  * New upstream release.

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 22 Apr 2011 02:58:49 +0200

ldb (1:1.0.2+git20110403-1) experimental; urgency=low

  * New upstream snapshot.
  * Switch to dh_python2. Closes: #616857

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 03 Apr 2011 21:51:32 +0200

ldb (1:1.0.2-2) unstable; urgency=low

  * Add symbols file for libpyldb-util.

 -- Jelmer Vernooij <jelmer@debian.org>  Mon, 28 Feb 2011 04:02:31 +0100

ldb (1:1.0.2-1) unstable; urgency=low

  * New upstream release.

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 27 Feb 2011 14:29:46 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,29 @@
 Section: devel
 Priority: optional
 Maintainer: Jelmer Vernooij <jelmer@debian.org>
-Build-Depends: debhelper (>> 6.0.7~), libtdb-dev (>= 1.2.9~), libtalloc-dev (>= 2.0.5~), libtevent-dev (>= 0.9.10~), pkg-config, libpopt-dev, docbook-xsl, docbook-xml, xsltproc, python-dev, python-support, python-tdb (>= 1.2.9~), libldap2-dev, python-talloc-dev (>= 2.0.5~)
+Build-Depends: debhelper (>> 6.0.7~),
+               docbook-xml,
+               docbook-xsl,
+               libldap2-dev,
+               libpopt-dev,
+               libtalloc-dev (>= 2.0.5~),
+               libtdb-dev (>= 1.2.9~),
+               libtevent-dev (>= 0.9.11~),
+               pkg-config,
+               python (>= 2.6.6-3),
+               python-all-dev (>= 2.6.6-3),
+               python-talloc-dev (>= 2.0.5~),
+               python-tdb (>= 1.2.9~),
+               xsltproc
 Homepage: http://ldb.samba.org/
 Standards-Version: 3.9.1
 Vcs-Bzr: http://bzr.debian.org/pkg-samba/ldb/unstable
-XS-Python-Version: all
+X-Python-Version: 2.6
 
 Package: libldb1
 Architecture: any
 Section: libs
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Replaces: libldb0
 Breaks: libldb0
 Description: LDAP-like embedded database - shared library
@@ -27,7 +40,7 @@
 Package: ldb-tools
 Section: utils
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: LDAP-like embedded database - tools
  ldb is a LDAP-like embedded database built on top of TDB.
  .
@@ -41,7 +54,12 @@
 Package: libldb-dev
 Section: libdevel
 Architecture: any
-Depends: libc6-dev, libldb1 (= ${binary:Version}), libtalloc-dev, pkg-config, libtdb-dev, ${misc:Depends}
+Depends: libc6-dev,
+         libldb1 (= ${binary:Version}),
+         libtalloc-dev,
+         libtdb-dev,
+         pkg-config,
+         ${misc:Depends}
 Description: LDAP-like embedded database - development files
  ldb is a LDAP-like embedded database built on top of TDB.
  .
@@ -55,9 +73,12 @@
 Package: python-ldb
 Section: python
 Architecture: any
-Depends: ${python:Depends}, libldb1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libldb1 (= ${binary:Version}),
+         ${misc:Depends},
+         ${python:Depends},
+         ${shlibs:Depends}
 Provides: ${python:Provides}
-XB-Python-Version: ${python:Versions}
+Breaks: ${python:Breaks}
 Description: Python bindings for LDB
  ldb is a LDAP-like embedded database built on top of TDB.
  .
@@ -66,7 +87,11 @@
 Package: python-ldb-dev
 Section: libdevel
 Architecture: any
-Depends: libc6-dev, python-ldb (= ${binary:Version}), libldb-dev, pkg-config, ${misc:Depends}
+Depends: libc6-dev,
+         libldb-dev,
+         pkg-config,
+         python-ldb (= ${binary:Version}),
+         ${misc:Depends}
 Description: LDB python bindings - development files
  ldb is a LDAP-like embedded database built on top of TDB.
  .

=== debian/rules ===
--- 
+++ 
@@ -13,10 +13,13 @@
 DESTDIR=$(CURDIR)/debian/tmp
 WAF=buildtools/bin/waf
 
+export PYTHON=$(shell which `pyversions -r`)
+
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
-	PYTHON=`which python` PYTHON_CONFIG=`which python-config` CFLAGS="$(CFLAGS)" ./configure --prefix=/usr --disable-rpath-install \
+	$(PYTHON) --version
+	CFLAGS="$(CFLAGS)" ./configure --prefix=/usr --disable-rpath-install \
 		--bundled-libraries=NONE \
 		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
 		--with-modulesdir=/usr/lib/ldb/modules
@@ -64,7 +67,7 @@
 	dh_compress
 	dh_fixperms
 	dh_makeshlibs -- -c4
-	dh_pysupport
+	dh_python2
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol
